package com.hotwj.platform.config.hiddenDangerCheckConfig.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.hotwj.platform.config.hiddenDangerCheckConfig.domain.HotHiddenDangerCheckConfig;
import com.hotwj.platform.config.hiddenDangerCheckConfig.domain.bo.HotHiddenDangerCheckConfigBo;
import com.hotwj.platform.config.hiddenDangerCheckConfig.domain.vo.HotHiddenDangerCheckConfigVo;
import com.hotwj.platform.config.hiddenDangerCheckConfig.mapper.HotHiddenDangerCheckConfigMapper;
import com.hotwj.platform.config.hiddenDangerCheckConfig.service.IHotHiddenDangerCheckConfigService;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.springframework.stereotype.Service;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * 隐患排查检查项配置Service业务层处理
 *
 * @author shihongwei
 * @date 2025-12-30
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class HotHiddenDangerCheckConfigServiceImpl implements IHotHiddenDangerCheckConfigService {

    private final HotHiddenDangerCheckConfigMapper baseMapper;

    /**
     * 查询隐患排查检查项配置
     *
     * @param id 主键
     * @return 隐患排查检查项配置
     */
    @Override
    public HotHiddenDangerCheckConfigVo queryById(Long id) {
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询隐患排查检查项配置列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 隐患排查检查项配置分页列表
     */
    @Override
    public TableDataInfo<HotHiddenDangerCheckConfigVo> queryPageList(HotHiddenDangerCheckConfigBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<HotHiddenDangerCheckConfig> lqw = buildQueryWrapper(bo);
        Page<HotHiddenDangerCheckConfigVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的隐患排查检查项配置列表
     *
     * @param bo 查询条件
     * @return 隐患排查检查项配置列表
     */
    @Override
    public List<HotHiddenDangerCheckConfigVo> queryList(HotHiddenDangerCheckConfigBo bo) {
        LambdaQueryWrapper<HotHiddenDangerCheckConfig> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<HotHiddenDangerCheckConfig> buildQueryWrapper(HotHiddenDangerCheckConfigBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<HotHiddenDangerCheckConfig> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(HotHiddenDangerCheckConfig::getId);
        lqw.eq(bo.getCompanyId() != null, HotHiddenDangerCheckConfig::getCompanyId, bo.getCompanyId());
        lqw.like(StringUtils.isNotBlank(bo.getTypeName()), HotHiddenDangerCheckConfig::getTypeName, bo.getTypeName());
        lqw.eq(bo.getIsDefault() != null, HotHiddenDangerCheckConfig::getIsDefault, bo.getIsDefault());
        lqw.eq(StringUtils.isNotBlank(bo.getCompanyInspectJson()), HotHiddenDangerCheckConfig::getCompanyInspectJson, bo.getCompanyInspectJson());
        lqw.eq(StringUtils.isNotBlank(bo.getVehicleInspectJson()), HotHiddenDangerCheckConfig::getVehicleInspectJson, bo.getVehicleInspectJson());
        lqw.eq(StringUtils.isNotBlank(bo.getPersonInspectJson()), HotHiddenDangerCheckConfig::getPersonInspectJson, bo.getPersonInspectJson());
        lqw.eq(bo.getIsDeleted() != null, HotHiddenDangerCheckConfig::getIsDeleted, bo.getIsDeleted());
        return lqw;
    }

    /**
     * 新增隐患排查检查项配置
     *
     * @param bo 隐患排查检查项配置
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(HotHiddenDangerCheckConfigBo bo) {
        HotHiddenDangerCheckConfig add = MapstructUtils.convert(bo, HotHiddenDangerCheckConfig.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改隐患排查检查项配置
     *
     * @param bo 隐患排查检查项配置
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(HotHiddenDangerCheckConfigBo bo) {
        HotHiddenDangerCheckConfig update = MapstructUtils.convert(bo, HotHiddenDangerCheckConfig.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(HotHiddenDangerCheckConfig entity) {
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除隐患排查检查项配置信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if (isValid) {
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
